/*
 * $Id: uart_hw.h,v 1.11 2006/07/12 07:24:36 poine Exp $
 *  
 * Copyright (C) 2005  Pascal Brisset, Antoine Drouin
 *
 * This file is part of paparazzi.
 *
 * paparazzi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * paparazzi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with paparazzi; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA. 
 *
 */

/** \file uart_hw.h
 *  \brief avr uart low level headers
 *
 */

#ifndef UART_HW_H
#define UART_HW_H

#include "std.h"
#include "uart_udp.h"
#include "uart_gpsd.h"



/************************************************************************/


#ifdef USE_UART0
// virtual uart that does udp-communication to
// the ground-station.

// the implementations of these functions
// are only frontends to the code in
// uart_udp.c
extern int Uart0ChAvailable();
extern uint8_t Uart0Getch();
extern void uart0_transmit(const uint8_t);
extern void uart0_init_tx(void);
extern void uart0_init_rx(void);
#endif

#ifdef USE_UART1
// virtual uart that does a tcp-connection to
// gpsd

// the implementations of these functions
// are only frontends to the code in
// uart_gpsd.c
extern void uart1_transmit(const uint8_t);
extern void uart1_init_tx(void);
extern void uart1_init_rx(void);
#endif


#endif /* UART_HW_H */
