#include "uart_udp.h"
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <string.h>

#ifdef USE_UART1

////////////////////////////////////////////////////
//  sending messages to the groundControlStation

/**
 * udpgcs = UDP-GroundControlStation.
 */
int                udpgcs_socketDescriptor;
unsigned short int udpgcs_serverPort = 4242;
struct sockaddr_in udpgcs_serverAddress;

void UDPuart_init_tx( void ) {
  struct hostent *udpgcs_hostInfo;
  printf("UDPuart_init_tx\n");

  udpgcs_socketDescriptor = socket(AF_INET, SOCK_DGRAM, 0);
  udpgcs_hostInfo = gethostbyname("127.0.0.1");  //TODO: make this a macro
  if (udpgcs_hostInfo == NULL) {
     printf("problem interpreting host: \n");
     return;
  }
  if (udpgcs_socketDescriptor < 0) {
    printf("cannot create UDP-socket to transmit to ground-control-station\n");
    return;
  }
  udpgcs_serverAddress.sin_family = udpgcs_hostInfo->h_addrtype;
  memcpy((char *) &udpgcs_serverAddress.sin_addr.s_addr, udpgcs_hostInfo->h_addr_list[0], udpgcs_hostInfo->h_length);
  udpgcs_serverAddress.sin_port = htons(udpgcs_serverPort);
}

unsigned char udpgcs_send_buffer[255];
unsigned int udpgcs_send_buffer_index = 0;

void UDPuart_transmit( unsigned char data ) {
//  printf("UDPuart_transmit(%i)\n",data);
  udpgcs_send_buffer[udpgcs_send_buffer_index] = data;
  udpgcs_send_buffer_index ++;
  if (udpgcs_send_buffer_index == 254) {
    printf("UDPuart_transmit() - buffer full, transmitting incomplete message\n");
    UDPUartSendMessage();
  }
}

void UDPUartSendMessage() {
  int i = 0;
  printf("UDPUartSendMessage() sending %i bytes\n", udpgcs_send_buffer_index);
  for (i = 0; i<udpgcs_send_buffer_index; i++) 
    printf("(%i)", udpgcs_send_buffer[i]);
  printf(" ");

  if (sendto(udpgcs_socketDescriptor, udpgcs_send_buffer, udpgcs_send_buffer_index, 0,
     (struct sockaddr *) &udpgcs_serverAddress, sizeof(udpgcs_serverAddress)) < 0) {
       printf("UDPUartSendMessage() cannot send data - closing socketDescriptor");
       close(udpgcs_socketDescriptor);
       return;
  } else {
       printf(" SENT\n");
  }

  udpgcs_send_buffer_index = 0;
}

////////////////////////////////////////////////////
//  receiving messages from the groundControlStation

void UDPuart_init_rx( void ) {
  printf("UDPuart_init_rx\n"); //TODO: implement receiving from the groundControlStation
}

int UDPuartChAvailable() {
  printf("UDPUartChAvailable()\n");
  return FALSE;
}

uint8_t UDPuartGetch() {
  printf("UDPUartGetch()\n");
  return 0;
}


#endif
